unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
  ComCtrls, FGL;

type
  TFPGListString = specialize TFPGList<ShortString>;
  TFPGListStringOne = class(TFPGListString);
  TFPGListStringTwo = class(TFPGListString);

var
  FPGListStringOne : TFPGListStringOne;
  FPGListStringTwo : TFPGListStringTwo;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button2: TButton;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RadioGroup1SelectionChanged(Sender: TObject);
  private
    procedure DumpList(const AList: TFPGListString);

  public
    function CurrentList:TFPGListString;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);

begin
  StatusBar1.SimpleText := Format('%s: %d',[CurrentList.ClassName,CurrentList.Count]);
end;

procedure TForm1.DumpList(const AList:TFPGListString);

var
  S:ShortString;

begin
Memo1.Lines.Clear;
for S in AList do
   Memo1.Lines.Add(S);
end;

procedure TForm1.Button2Click(Sender: TObject);

var
  S: ShortString;

begin
  S := DateTimeToStr(Now());
  CurrentList.Add(S);
  DumpList(CurrentList);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPGListStringOne := TFPGListStringOne.Create;
  FPGListStringOne.add('One');
  FPGListStringTwo := TFPGListStringTwo.Create;
  FPGListStringTwo.add('Two');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

end;

procedure TForm1.RadioGroup1SelectionChanged(Sender: TObject);
begin
DumpList(CurrentList);
end;

function TForm1.CurrentList: TFPGListString;

begin
  case RadioGroup1.ItemIndex of
  0: result := FPGListStringOne;
  1: result := FPGListStringTwo;
  end;
end;

end.

